<?php

namespace app\admin\controller\school\classes\order;

use app\common\controller\Backend;

/**
 * 机构课程订单
 *
 * @icon fa fa-circle-o
 */
class Order extends Backend
{

    /**
     * Order模型对象
     * @var \app\admin\model\school\classes\order\Order
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\school\classes\order\Order;
        $this->view->assign("payTypeList", $this->model->getPayTypeList());
        $this->view->assign("statusList", $this->model->getStatusList());
        $this->view->assign("beforeStatusList", $this->model->getBeforeStatusList());
        $this->view->assign("serverStatusList", $this->model->getServerStatusList());
        $this->view->assign("resultStatusList", $this->model->getResultStatusList());
        $this->getAuthMsg();
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        $this->searchFields = ["id","order_no","pay_no","user_id","code","shop.name","detail.title","user.nickname","user.realname","user.mobile"];

        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['manystore','user','shop','lib','detail','admin'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('manystore')->visible(['nickname','avatar']);
				$row->getRelation('user')->visible(['nickname','realname','mobile','avatar']);
				$row->getRelation('shop')->visible(['name','image','address_city','province','city','district','address','address_detail']);
				$row->getRelation('lib')->visible(['title','headimage']);
				$row->getRelation('detail')->visible(['title','headimage',"feel","teacher_id"]);
				$row->getRelation('admin')->visible(['nickname','avatar']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    /**
     * 课程订单取消
     * @return string
     * @throws \think\Exception
     * @throws \think\db\exception\BindParamException
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     */
    public function cancel($ids = ''){
        $param = $this->request->param();
        if($this->request->isPost()){
            try{
                if(isset($param['ids']))$ids = $param['ids'];
                //设置模拟资格
                $model = (new \app\common\model\school\classes\order\Order);
                $model->cancel($ids,0,true,'admin',$this->auth->id,true);


            }catch (\Exception $e){
                $this->error($e->getMessage());
            }
            $this->success('取消成功!');
        }
        $row = $this->model->get($ids);
        $this->view->assign('vo', $row);
        return $this->view->fetch();
    }



        /**发起售后
     * @return string
     * @throws \think\Exception
     * @throws \think\exception\DbException
     */
    public function after_sales($ids = ""){

        if($this->request->isPost())
        {
            try{
                $params = $this->request->post("row/a");
                $classes_order = $params["id"];
                $reason = $params["reason"];


                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                   $remark = "总后台管理员帮忙下售后单";
                $order = $model->afterSales($classes_order,$reason,$remark,'admin',$this->auth->id,true);

                $price = $params["price"];
                $status = "yes";
                $reject_reason = "";
                $reject_images = "";
                $model = (new \app\common\model\school\classes\order\ServiceOrder());
                $model->shopConfirmation($order["order_no"],$status,$price,$reject_reason,$reject_images,0,true,'admin',$this->auth->id,true);



            }catch (\Exception $e){
                $this->error($e->getMessage());
            }
            $this->success("执行成功");
        }

        $row = $this->model->where(array('id'=>$ids))->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }
        $order_info = \app\common\model\school\classes\order\ServiceOrder::getCost("43246634123432564",$ids,"",[],true);
//        $row = $this->model->get($param['ids']);
        $this->view->assign('row',array_merge($row->toArray(),$order_info));
        return $this->view->fetch();
    }


}
